VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "JsonBag Testbed"
   ClientHeight    =   6990
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   10695
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6990
   ScaleWidth      =   10695
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdGenSerialize 
      Caption         =   "Gen && Serialize"
      Height          =   495
      Left            =   7020
      TabIndex        =   7
      Top             =   6000
      Width           =   1515
   End
   Begin VB.CheckBox chkWhiteSpace 
      Caption         =   "Add Whitespace"
      Height          =   495
      Left            =   1800
      TabIndex        =   0
      Top             =   6000
      Width           =   1695
   End
   Begin VB.CommandButton cmdCutPasteBack 
      Caption         =   "Cut/Paste Back"
      Height          =   495
      Left            =   5340
      TabIndex        =   2
      Top             =   6000
      Width           =   1515
   End
   Begin VB.CommandButton cmdParseReser 
      Caption         =   "Parse/Reser"
      Height          =   495
      Left            =   3660
      TabIndex        =   1
      Top             =   6000
      Width           =   1515
   End
   Begin VB.TextBox txtSerialized 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2055
      Left            =   4680
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   420
      Width           =   4515
   End
   Begin VB.TextBox txtOriginal 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2055
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Text            =   "Form1.frx":0000
      Top             =   420
      Width           =   4455
   End
   Begin VB.Label lblDeserReser 
      Caption         =   "Parsed/Reserialized"
      Height          =   255
      Left            =   4680
      TabIndex        =   6
      Top             =   60
      Width           =   3015
   End
   Begin VB.Label lblOriginal 
      Caption         =   "Original"
      Height          =   255
      Left            =   60
      TabIndex        =   5
      Top             =   60
      Width           =   3015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private GapHorizontal As Single
Private GapVertical As Single

Private JB As JsonBag

Private Sub chkWhiteSpace_Click()
    JB.Whitespace = chkWhiteSpace.Value = vbChecked
End Sub

Private Sub cmdCutPasteBack_Click()
    txtOriginal.Text = txtSerialized.Text
    txtSerialized.Text = vbNullString
    
    cmdParseReser.SetFocus
End Sub

Private Sub cmdGenSerialize_Click()
    With JB
        .Clear
        .IsArray = False 'Actually the default after Clear.
        
        ![First] = 1
        ![Second] = Null
        With .AddNewArray("Third")
            .Item = "These"
            .Item = "Add"
            .Item = "One"
            .Item = "After"
            .Item = "The"
            .Item = "Next"
            .Item(1) = "*These*" 'Should overwrite 1st Item, without moving it.
            
            'Add a JSON "object" to this "array" (thus no name supplied):
            With .AddNewObject()
                .Item("A") = True
                !B = False
                !C = 3.14E+16
            End With
        End With
        With .AddNewObject("Fourth")
            .Item("Force Case") = 1 'Use quoted String form to force case of names.
            .Item("force Case") = 2
            .Item("force case") = 3
            
            'This syntax can be risky with case-sensitive JSON since the text is
            'treated like any other VB identifier, i.e. if such a symbol ("Force"
            'or "Case" here) is already defined in the language (VB) or in your
            'code the casing of that symbol will be enforced by the IDE:
            
            ![Force Case] = 666 'Should overwrite matching-case named item, which
                                'also moves it to the end.
            'Safer:
            .Item("Force Case") = 666
        End With
        'Can also use implied (default) property:
        JB("Fifth") = Null
        
        txtSerialized.Text = .JSON
    End With
End Sub

Private Sub cmdParseReser_Click()
    Dim NewJB As JsonBag
    Dim NewIndex As Long
    Dim ErrDesc As String
    
    'Parse JSON text into JsonBag:
    On Error Resume Next
    JB.JSON = txtOriginal.Text
    If Err Then
        MsgBox "Error " & CStr(Err.Number) & vbNewLine & vbNewLine _
             & Err.Description
        ErrDesc = Err.Description
        On Error GoTo 0
        ErrDesc = Mid$(ErrDesc, InStrRev(ErrDesc, " ") + 1)
        If IsNumeric(ErrDesc) Then
            txtOriginal.SelStart = CLng(ErrDesc) - 1
            txtOriginal.SelLength = 1
            txtOriginal.SetFocus
        End If
        Exit Sub
    End If
    On Error GoTo 0
    
    txtSerialized.Text = JB.JSON
    
    cmdCutPasteBack.SetFocus
End Sub

Private Sub Form_Load()
    GapHorizontal = lblOriginal.Left
    GapVertical = lblOriginal.Top

    Set JB = New JsonBag
    JB.Whitespace = chkWhiteSpace.Value = vbChecked
End Sub

Private Sub Form_Resize()
    Dim TxtWidth As Single
    Dim TxtHeight As Single
    Dim BtnsLeft As Single
    
    If WindowState <> vbMinimized Then
        TxtWidth = (ScaleWidth - 3# * GapHorizontal) / 2#
        TxtHeight = ScaleHeight - (3# * GapVertical _
                                     + lblOriginal.Height _
                                     + cmdParseReser.Height)
        BtnsLeft = (ScaleWidth - (chkWhiteSpace.Width _
                                + cmdParseReser.Width _
                                + cmdCutPasteBack.Width _
                                + cmdGenSerialize.Width _
                                + 5# * GapHorizontal)) / 2#
        With txtOriginal
            .Move GapHorizontal, lblOriginal.Height + GapVertical, TxtWidth, TxtHeight
            txtSerialized.Move 2# * GapHorizontal + .Width, .Top, TxtWidth, TxtHeight
            lblDeserReser.Left = txtSerialized.Left
            chkWhiteSpace.Move BtnsLeft, .Top + .Height + GapVertical
        End With
        With chkWhiteSpace
            cmdParseReser.Move .Left + .Width + GapHorizontal, .Top
        End With
        With cmdParseReser
            cmdCutPasteBack.Move .Left + .Width + GapHorizontal, .Top
        End With
        With cmdCutPasteBack
            cmdGenSerialize.Move .Left + .Width + GapHorizontal, .Top
        End With
    End If
End Sub
